package com.skyversation.poiaddr.bean;


import com.alibaba.fastjson.JSONObject;
import com.skyversation.poiaddr.util.status.AddressResultEnum;

import java.io.Serializable;
import java.util.List;

@lombok.Data
public class AddressResult {

    public AddressResult(){};
    public AddressResult(AddressResultEnum code, String message){
        this.code = code;
        this.message = message;
    };

    // 查询结果码 -1 token获取失败； 0 成功；
    private AddressResultEnum code;
    // 查询状态信息
    private String message;

    private List<ContentBean> data;
    @lombok.Data
    public static class ContentBean implements Serializable {
        // 省份名称
        private String pname;
        // 城市名称
        private String cityname;
        // 街镇名称
        private String adname;
        // 居委
        private String community;
        // 居委编码
        private String communityCode;
        // 结果类型
        private String type;
        // 地址
        private String address;
        // 搜索地址
        private String searchAddress;
        // 距离
        private String distance;
        // 地址名称
        private String name;
        // 经纬度
        private String location;
        // 纬度
        private Double lat;
        // 经度
        private Double lon;
        // 村居信息
        private JSONObject cjJson;
        // 网格信息
        private JSONObject wgJson;
        // 微格网信息
        private JSONObject wgwJson;
        // 行政区划信息
        private JSONObject adJson;
        // 街镇信息
        private JSONObject townJson;
    }

}
