package com.skyversation.poiaddr.bean;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.Formula;
import org.hibernate.annotations.Type;
import org.springframework.data.domain.Persistable;

import javax.persistence.*;
import java.time.Instant;

@Getter
@Setter
@Entity
@Table(name = "yysz_address_qp")
@AllArgsConstructor
@NoArgsConstructor
public class YyszAddressQp implements Persistable<Integer> {
    @Transient
    @Override
    public boolean isNew() {
        return true;
    }

    @Id
    @Column(name = "oid", nullable = false)
    private Integer id;

    @Column(name = "code")
    private String code;

    @Column(name = "sourceaddress", length = 500)
    private String sourceaddress;

    @Column(name = "city")
    private String city;

    @Column(name = "county")
    private String county;

    @Column(name = "town")
    private String town;

    @Column(name = "community")
    private String community;

    @Column(name = "village")
    private String village;

    @Column(name = "squad")
    private String squad;

    @Column(name = "szone")
    private String szone;

    @Column(name = "street")
    private String street;

    @Column(name = "door")
    private String door;

    @Column(name = "resregion")
    private String resregion;

    @Column(name = "building")
    private String building;

    @Column(name = "building_num")
    private String buildingNum;

    @Column(name = "unit")
    private String unit;

    @Column(name = "floor")
    private String floor;

    @Column(name = "room")
    private String room;

    @Column(name = "unique_code")
    private String uniqueCode;

    @Column(name = "room_of_floor")
    private Integer roomOfFloor;

    @Column(name = "source")
    private String source;

    @Column(name = "lon")
    private Double lon;

    @Column(name = "lat")
    private Double lat;

    @Column(name = "shape")
    private String shape;

    @Column(name = "belong_building")
    private String belongBuilding;

    @Column(name = "address_type")
    private Integer addressType;

    @Column(name = "lv")
    private Integer lv;

    @Column(name = "is_delete")
    private Integer isDelete;

    @Column(name = "is_multi")
    private Integer isMulti;

    @Column(name = "createtime")
    private Instant createtime;

    @Column(name = "updatetime")
    private Instant updatetime;

    @Column(name = "alt")
    private Double alt;

    @Column(name = "model_type")
    private Integer modelType;

    @Column(name = "full_place")
    private String fullPlace;

    @Column(name = "security_grade")
    private Integer securityGrade;

    @Column(name = "city_code")
    private String cityCode;

    @Column(name = "county_code")
    private String countyCode;

    @Column(name = "town_code")
    private String townCode;

    @Column(name = "community_code")
    private String communityCode;

    @Column(name = "grid_name")
    private String gridName;

    @Column(name = "grid_code")
    private String gridCode;

    @Column(name = "data_type", length = 50)
    private String dataType;

    @Column(name = "mphid", length = 100)
    private String mphid;

    @Column(name = "address_code", length = 100)
    private String addressCode;

    @Column(name = "systemid", length = 100)
    private String systemid;

    @Column(name = "type", length = 10)
    private String type;

    @Column(name = "x")
    private String x;

    @Column(name = "y")
    private String y;

    @Column(name = "label", length = 50)
    private String label;

    @Column(name = "addr_tag")
    private String addrTag;

    @Column(name = "multiple_unique")
    private String multipleUnique;

    @Column(name = "standardize_task_id")
    private String standardizeTaskId;

    @Column(name = "dlhh")
    private String dlhh;

    @Column(name = "signature_data")
    @Type(type = "org.hibernate.type.TextType")
    private String signatureData;

    @Column(name = "signature_check_state")
    private Integer signatureCheckState;

    @Column(name = "signature_time")
    private Instant signatureTime;

    @Column(name = "signature_check_time")
    private Instant signatureCheckTime;

    @Column(name = "is_history")
    private Integer isHistory;

    @Column(name = "ylmc")
    private String ylmc;

    @Column(name = "ylbm", length = 50)
    private String ylbm;

    @Column(name = "address")
    private String address;

    @Column(name = "ybdd", length = 50)
    private String ybdd;

    @Formula("ST_AsText(geom)")
    @Transient
    private String location;

    @Column(name = "tydz_jc", length = 50)
    private String tydzJc;
}