package com.skyversation.poiaddr.entity;


import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import java.io.Serializable;
import java.util.Map;

@AllArgsConstructor
@NoArgsConstructor
@Data
/**
 * 地名地址查询返回实体类
 * 文件名编码格式result[_匹配等级][_匹配距离][_区域名称][_坐标系].[文件类型]
 */
public class FileDataDto implements Serializable {
//  查询地址1
    private String addr1;
//  查询地址2
    private String addr2;
//  查询结果经度(默认返回的都是wgs84)
    private Double resultLat;
//  查询结果纬度(默认返回的都是wgs84)
    private Double resultLon;
//  参考经度（可能为空）
    private Double lat;
//  参考纬度（可能为空）
    private Double lon;
//  匹配等级
    private Integer matchingLevel;
//  匹配距离（可能为空）
    private double matchingDistance;
//  是否小于匹配距离（可能为空）
    private String ltMatchingDistance;
//  是否在区域内（可能为空）
    private String inTheArea;
//  geojson geometry
    private GeometryDiy geometry;
//  所有属性
    private Map<String,Object> properties;
}
