package com.skyversation.poiaddr.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Id;
import java.io.Serializable;
import java.util.Date;

/**
 * @Description  
 * @Author  LiuMengxiang
 * @Date 2025-03-13 13:38:37 
 */

@AllArgsConstructor
@NoArgsConstructor
@Data
@Entity
@Table ( name ="test_data" , schema = "")
public class TestData  implements Serializable {

	private static final long serialVersionUID =  5402991726683110730L;

	/**
	 * 主键
	 */
	@Id
   	@Column(name = "id" )
	private String id;

	/**
	 * 实口地址
	 */
   	@Column(name = "sk_hjdz" )
	private String skHjdz;

	/**
	 * 实口居住
	 */
   	@Column(name = "sk_jzdz" )
	private String skJzdz;

	/**
	 * 基层户籍
	 */
   	@Column(name = "jc_hjdz" )
	private String jcHjdz;

	/**
	 * 基层居住
	 */
   	@Column(name = "jc_jzdz" )
	private String jcJzdz;

	/**
	 * 社区云户籍
	 */
   	@Column(name = "sqy_hjdz" )
	private String sqyHjdz;

	/**
	 * 社区云居住
	 */
   	@Column(name = "sqy_jzdz" )
	private String sqyJzdz;

	/**
	 * 匹配等级
	 */
   	@Column(name = "level" )
	private String level;

	/**
	 * 行政区划
	 */
   	@Column(name = "administrative_division" )
	private String administrativeDivision;

	/**
	 * 城市
	 */
   	@Column(name = "market" )
	private String market;

	/**
	 * 所属街镇
	 */
   	@Column(name = "twon" )
	private String twon;

	/**
	 * 经度
	 */
   	@Column(name = "lat" )
	private String lat;

	/**
	 * 纬度
	 */
   	@Column(name = "lon" )
	private String lon;

	/**
	 * 是否在松江区
	 */
   	@Column(name = "in_the_area" )
	private String inTheArea;

	/**
	 * 更新时间
	 */
   	@Column(name = "update_time" )
	private Date updateTime;

	/**
	 * 查询地址
	 */
   	@Column(name = "result_addr_key" )
	private String resultAddrKey;

	/**
	 * 规范化地址
	 */
   	@Column(name = "standardized_address" )
	private String standardizedAddress;
}
