package com.skyversation.poiaddr.repository;

import com.skyversation.poiaddr.bean.TAddressCallback;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.Optional;

public interface TAddressCallbackRep extends JpaRepository<TAddressCallback,Integer> {
    @Query(value = "SELECT MAX(e.id) FROM t_address_callback e", nativeQuery = true)
    Optional<Integer> findMaxId();
    @Query(value = "SELECT DISTINCT t.address FROM t_address_callback t where t.process_status = 0 or t.process_status = 1",
            countQuery = "SELECT COUNT(DISTINCT a.address) FROM t_address_callback a WHERE t.process_status = 0 or t.process_status = 1",nativeQuery = true)
    Page<String> findAllInNative(Pageable pageable);
    @Query(value = "update t_address_callback set process_status = :status where address = :target",nativeQuery = true)
    @Modifying
    void updateAllProcessStatus(String target, Integer status);
}
