package com.skyversation.poiaddr.util.address_spliter;

import lombok.Data;

/**
 * 分割后的数据
 * @see SplitAddress#status
 * @see ShanghaiAddressSplitUtil
 */
@Data
public class SplitAddress implements Comparable<SplitAddress>{
    private String fullAddress;
    private String sourceAddress;
    /**
     * 0->正常<br/>
     * 1->未分离区一下地址（不代表数据不可用，有可能是源地址中不存在任何行政区划）<br/>
     * 2->外省数据<br/>
     * 3->非地址（检查到源地址非正常地址,例如网址）<br/>
     * 4->无法确认是否为外省
     */
    private int status;
    private String addr = "";
    private String province = "";
    private String city = "";
    private String district = "";
    private String street = "";
    private String community="";
    private String cityCode = "";
    private String districtCode = "";
    private String streetCode = "";
    private String communityCode="";
    private String searchAddr;
    public boolean isSuccess(){
        switch (status){
            case 0: case 1: case 4:{
                return true;
            }
            case 2: case 3: default:{
                return false;
            }
        }
    }
    @Override
    public String toString() {
        return "AddressInfo{" +
                "sourceAddress='" + sourceAddress + '\'' +
                "fullAddress='" + fullAddress + '\'' +
                ", status=" + status +
                ", addr='" + addr + '\'' +
                ", province='" + province + '\'' +
                ", city='" + city + '\'' +
                ", district='" + district + '\'' +
                ", street='" + street + '\'' +
                ", community='" + community + '\'' +
                '}';
    }
    private int point(){
        int output=0;
        if (status==0||status==1)output+=1000;
        if (status==4)output+=800;
        if (district.isEmpty())output-=100;
        if (street.isEmpty())output-=100;
        if (community.isEmpty())output-=100;
        return  output;

    }
    @Override
    public int compareTo(SplitAddress o)throws NullPointerException {
        return this.point()-o.point();
    }
}
