package com.skyversation.poiaddr.util.dms;

import com.skyversation.poiaddr.addquery.Constant;
import com.skyversation.poiaddr.util.RequestUtils;
import org.json.JSONArray;
import org.json.simple.JSONObject;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DmsTools {
    public static String DmsToken;

    //  登录操作，请求token
    public static String getDmsToken() {
        JSONObject resultObject = RequestUtils.requestPost(Constant.Oauth_login_URL, null, null);
        if (resultObject != null && resultObject.containsKey("message") && resultObject.get("message") != null) {
            DmsToken = resultObject.get("message").toString();
        }
        return DmsToken;
    }

    public static JSONObject selectDms(String columnId) {
        Map<String, String> headers = new HashMap<>();
        if (DmsToken != null && DmsToken.length() > 0) {
            headers.put("Token", DmsToken);
        } else {
            headers.put("Token", getDmsToken());
        }
        Map<String, String> formDatas = new HashMap<>();
        formDatas.put("columnId", columnId);
        formDatas.put("states", "0");
        formDatas.put("pageSize", "9999");
        formDatas.put("page", "0");
        return RequestUtils.requestPost(Constant.DMS_selectContentList_URL, headers, formDatas);
    }

    public static JSONObject addContent(org.json.JSONObject formDatas) {
        Map<String, String> headers = new HashMap<>();
        if (DmsToken != null && DmsToken.length() > 0) {
            headers.put("Token", DmsToken);
        } else {
            headers.put("Token", getDmsToken());
        }
        return RequestUtils.requestPost2(Constant.DMS_addContent_URL, headers, formDatas);
    }

    public static JSONObject updateContent(org.json.JSONObject formDatas) {
        Map<String, String> headers = new HashMap<>();
        if (DmsToken != null && DmsToken.length() > 0) {
            headers.put("Token", DmsToken);
        } else {
            headers.put("Token", getDmsToken());
        }
        return RequestUtils.requestPost2(Constant.DMS_updateContent_URL, headers, formDatas);
    }
}
