package com.skyversation.poiaddr.util.geotools;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.locationtech.jts.geom.Coordinate;
import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.geom.GeometryFactory;
import org.locationtech.jts.io.ParseException;
import java.io.IOException;

/**
 * 根据经纬度和geojson字符串，判断是否是包含关系
 */
public class GeoJsonPointInRegion {

    public static boolean isPointInGeoJsonRegion(String geoJson, double longitude, double latitude) throws IOException, ParseException {
        ObjectMapper mapper = new ObjectMapper();
        // 将GeoJSON字符串解析成Geometry对象
        Geometry geo = mapper.readValue(geoJson, Geometry.class);

        GeometryFactory geometryFactory = new GeometryFactory();
        // 创建表示点的Geometry对象
        Coordinate point = new Coordinate(longitude, latitude);
        Geometry pointGeom = geometryFactory.createPoint(point);

        return geo.contains(pointGeom);
    }

    /*public static void main(String[] args) {
        String sampleGeoJson = "{\"type\":\"Polygon\",\"coordinates\":[[[116.3,39.9],[116.4,39.9],[116.4,40.0],[116.3,40.0],[116.3,39.9]]]}";
        double lon = 116.35;
        double lat = 39.95;
        try {
            boolean result = isPointInGeoJsonRegion(sampleGeoJson, lon, lat);
            if (result) {
                System.out.println("点在区域内");
            } else {
                System.out.println("点不在区域内");
            }
        } catch (IOException | ParseException e) {
            e.printStackTrace();
        }
    }*/
}