package com.skyversation.poiaddr.util.geotools;
import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.geom.GeometryFactory;
import org.locationtech.jts.io.ParseException;
import org.locationtech.jts.io.WKTReader;

/**
 * 创建 GeometryFactory 和 WKTReader：
 * GeometryFactory 用于创建各种几何对象。
 * WKTReader 用于将 Well-Known Text (WKT) 格式的字符串转换为 Geometry 对象。
 * 定义几何对象：
 * 这里使用 WKT 字符串来表示几何对象。wkt1 和 wkt2 分别表示两个多边形。你可以根据需要修改这些字符串，它们可以是任何支持的几何类型，如 POINT、LINESTRING、POLYGON 等。
 * 将 WKT 字符串解析为 Geometry 对象：
 * 使用 wktReader.read(wkt) 方法将 WKT 字符串转换为 Geometry 对象。
 * 相交判断：
 * geometry1.intersects(geometry2) 方法用于判断 geometry1 和 geometry2 是否相交。
 * 如果相交，返回 true，否则返回 false。
 * 相离判断：
 * geometry1.disjoint(geometry2) 方法用于判断 geometry1 和 geometry2 是否相离。
 * 如果相离，返回 true，否则返回 false。
 */
public class GeometryIntersectionAndDisjoint {

    /*public static void main(String[] args) {
        GeometryFactory geometryFactory = new GeometryFactory();
        WKTReader wktReader = new WKTReader(geometryFactory);

        try {
            // 定义两个几何对象，这里使用 WKT 格式的字符串表示
            String wkt1 = "POLYGON((0 0, 0 10, 10 10, 10 0, 0 0))";
            String wkt2 = "POLYGON((5 5, 5 15, 15 15, 15 5, 5 5))";

            // 将 WKT 字符串解析为 Geometry 对象
            Geometry geometry1 = wktReader.read(wkt1);
            Geometry geometry2 = wktReader.read(wkt2);

            // 判断两个几何对象是否相交
            boolean intersects = geometry1.intersects(geometry2);
            System.out.println("两个几何对象是否相交: " + intersects);

            // 判断两个几何对象是否相离
            boolean disjoint = geometry1.disjoint(geometry2);
            System.out.println("两个几何对象是否相离: " + disjoint);

            // 判断 geometry2 是否包含 geometry1
            boolean containsReverse = geometry2.contains(geometry1);
            System.out.println("geometry2 是否包含 geometry1: " + containsReverse);

            // 计算几何对象的面积
            double area = geometry2.getArea();
            System.out.println("该几何对象的面积为: " + area);
        } catch (ParseException e) {
            e.printStackTrace();
        }
    }*/
}