package com.skyversation.poiaddr.util.tasks;

import com.skyversation.poiaddr.service.impl.TestDataServiceImpl;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import javax.annotation.Resource;
import java.util.Date;

@Component
public class ScheduledTasks {

    @Resource
    private TestDataServiceImpl testDataService;

    /**
     * 每天 1 点执行的方法
     * 全量跑C表数据
     */
    @Scheduled(cron = "0 0 1 * * *")
    public void executeAtOneOClock() {
        System.out.println("每天 1 点执行的方法，当前时间：" + new Date());
        // 在这里编写具体的业务逻辑
        testDataService.iterativeProcessing(1000, 1, 0);
    }
}