package com.skyversation.poiaddr.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.skyversation.poiaddr.util.net.AddressNetTools;
import org.springframework.http.ResponseEntity;
import org.springframework.util.StringUtils;

import java.io.IOException;
import java.util.*;

/**
 * 政务网
 */
public class 根据jsonarray查询地址_四中心搜索_V4 {
    public static final String szxUrl = "https://service-api.onemap.sh.gov.cn/data-service-manage-service/MapProxyApi/eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhcHBsaWNhdGlvbl9pZCI6NjEsImFwcGxpY2F0aW9uX25hbWUiOiLpnZLmtabkuozkuInnu7TmnI3liqHns7vnu58iLCJleHAiOjIwNDY2Nzg0MDN9.IKUMdjUX4U1jncIUNren-iotL7duXI90aLECMjpvUX8/address_search/MapServer?region=310118&page_num=1&page_size=10&query=";
    public static final String v4Url = "http://10.235.245.174:10011/proxy/address/getAddressV4?token=65463DEE-620A-0ED5-2385-17ECD07CD351&address=";
    //  TODO 是否使用市中心的返回方法
    public static final Boolean ifSzxResult = true;

    public static void main(String[] args) {
        String path = "D:\\work\\晗哥\\城建所\\数据处理\\赵巷单位2.xlsx";
        String outputPath = "D:\\work\\晗哥\\城建所\\数据处理\\output赵巷单位2.xlsx";
//        // V4地名地址，结果：33空地址，地址不完全匹配
        searchLocToV4ByAddress("上海市青浦区", "经营地址", path, outputPath);


    }

    public static void searchLocToV4ByAddress(String heaeName, String addressKey, String path, String outputPath) {
        try {
            List<Map<String, Object>> listAddr = ExcelReaderUtils.readExcel(path);
            int size = (listAddr.size() / 1000) + 1;
            System.out.println("<<<<<<<   " + size + "     >>>>>>>>>");
//            ExecutorService executor = Executors.newFixedThreadPool(size);
//            for(int i = 0; i < size; i ++){

//                List<Map<String, String>> list = listAddr.subList(i * 1000, (i+1)*1000 > listAddr.size() ? listAddr.size(): (i+1)*1000);
            List<Map<String, Object>> list = listAddr;

//                executor.execute(() ->{
            List<Map<String, Object>> result = new ArrayList<>();
            for (Map<String, Object> map : list) {
                if (map.get("搜索结果地址") != null && StringUtils.hasText(map.get("搜索结果地址").toString())) {
                    result.add(map);
                } else {
                    // 开始查询
                    String address = map.get(addressKey).toString().trim().replaceAll("-", "");
                    address = address.replace("上海市", "");
                    address = address.replace("青浦区", "");
                    address = heaeName + address;
                    ResponseEntity response = AddressNetTools.getInstance().requestGet((ifSzxResult ? szxUrl : v4Url) + address, null, null, 1);
                    if (response != null) {
                        JSONObject json = JSONObject.parseObject(response.getBody() + "");
                        JSONArray array = null;
                        if (ifSzxResult) {
//                          TODO 市中心搜索方法
                            array = json.getJSONArray("result");
                        } else {
//                          TODO V4搜索方法
                            JSONObject content = json.getJSONObject("content");
                            int resultCode = content.getInteger("resultCode");
                            if (resultCode == 0) {
                                array = content.getJSONArray("exactResult");
                            } else {
                                array = content.getJSONArray("recomResult");
                            }
                        }
                        if (array == null || array.size() < 1) {
//                            map.put("所属区县", " ");
//                            map.put("所属街道", " ");
                            map.put("搜索结果纬度", " ");
                            map.put("搜索结果经度", " ");
//                            map.put("所属居委", " ");
                            map.put("是否精确", "否");
                            map.put("搜索结果地址", "");
                        } else {
                            for (int j = 0; j < array.size(); j++) {
                                JSONObject jsonRes = array.getJSONObject(j);
                                String lng = "";
                                String lat = "";
                                String resultAddrKey = jsonRes.getString(ifSzxResult ? "address" : "搜索结果地址");
                                if (ifSzxResult && jsonRes.getJSONObject("location") != null && jsonRes.getJSONObject("location").get("lng") != null && jsonRes.getJSONObject("location").get("lat") != null) {
                                    lng = jsonRes.getJSONObject("location").getDoubleValue("lng") + "";
                                    lat = jsonRes.getJSONObject("location").getDoubleValue("lat") + "";
                                } else if (jsonRes.get("纬度") != null && jsonRes.get("经度") != null) {
                                    lng = jsonRes.getDoubleValue("纬度") + "";
                                    lat = jsonRes.getDoubleValue("经度") + "";
                                } else {
                                    map.put("搜索结果纬度", "");
                                    map.put("搜索结果经度", "");
                                    map.put("搜索结果地址", "");
                                    continue;
                                }
                                map.put("搜索结果纬度", lng);
                                map.put("搜索结果经度", lat);
                                map.put("搜索结果地址", resultAddrKey);
//                              map.put("所属区县", jsonRes.getString("所属区县"));
//                              map.put("所属街道", jsonRes.getString("所属街道"));
//                              map.put("所属居委", jsonRes.getJSONObject("村居信息").getString("所属居委"));
                                if (("上海市青浦区" + resultAddrKey).contains(address.replace("上海市青浦区", ""))) {
                                    map.put("是否精确", "是");
                                    break;
                                } else if (resultAddrKey != null && !resultAddrKey.isEmpty() && address.contains(resultAddrKey.replace("上海市青浦区", ""))) {
                                    map.put("是否精确", "近似");
                                    break;
                                } else {
                                    double lat1 = Double.parseDouble(map.get("经度") + "");
                                    double lon1 = Double.parseDouble(map.get("纬度") + "");
                                    double lat2 = Double.parseDouble(lat);
                                    double lon2 = Double.parseDouble(lng);
                                    if (Coordinate.calculateDistance(lat1, lon1, lat2, lon2) <= 100) {
                                        map.put("是否精确", "接近100m");
                                        break;
                                    } else {
                                        map.put("搜索结果纬度", "");
                                        map.put("搜索结果经度", "");
                                        map.put("搜索结果地址", "");
                                        continue;
                                    }
                                }
                            }

                            if (!ifSzxResult && !StringUtils.hasText(map.get("搜索结果经度") + "")) {
                                boolean isError = false;
                                JSONObject json1 = array.getJSONObject(0);
                                if (json1.getString("搜索结果地址").length() < 5) {
                                    try {
                                        json1 = array.getJSONObject(1);
                                    } catch (Exception e) {
                                        isError = true;
//                                        map.put("所属区县", " ");
//                                        map.put("所属街道", " ");
                                        map.put("搜索结果纬度", " ");
                                        map.put("搜索结果经度", " ");
//                                        map.put("所属居委", " ");
                                        map.put("是否精确", "否");
                                        map.put("搜索结果地址", "");
                                    }
                                }
                                if (!isError) {
//                                    JSONObject jsonWWG = json1.getJSONObject("微格网信息");
//                                    map.put("所属区县", jsonWWG.getString("所属区县"));
//                                    map.put("所属街道", jsonWWG.getString("所属街道"));
                                    map.put("搜索结果纬度", json1.getDoubleValue("纬度") + "");
                                    map.put("搜索结果经度", json1.getDoubleValue("经度") + "");
                                    map.put("是否精确", "否");
                                    map.put("搜索结果地址", json1.getString("搜索结果地址"));
//                                    map.put("所属居委", json1.getJSONObject("村居信息").getString("所属居委"));
                                }
                            }
                        }
                    }
                    result.add(map);
                }
            }
            try {
                ExcelReaderUtils.writeToExcel(result, outputPath.replace(".xlsx", UUID.randomUUID().toString() + ".xlsx"));
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
//                });

//            }
//            executor.shutdown();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
